~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/lib/bpf/Makefile

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

  1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2 # Most of this file is copied from tools/lib/traceevent/Makefile
  3 
  4 RM ?= rm
  5 srctree := $(realpath $(srctree))
  6 
  7 VERSION_SCRIPT := libbpf.map
  8 LIBBPF_VERSION := $(shell \
  9         grep -oE '^LIBBPF_([0-9.]+)' $(VERSION_SCRIPT) | \
 10         sort -rV | head -n1 | cut -d'_' -f2)
 11 LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$(LIBBPF_VERSION)))
 12 LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$(LIBBPF_VERSION)))
 13 
 14 MAKEFLAGS += --no-print-directory
 15 
 16 # This will work when bpf is built in tools env. where srctree
 17 # isn't set and when invoked from selftests build, where srctree
 18 # is a ".". building_out_of_srctree is undefined for in srctree
 19 # builds
 20 ifndef building_out_of_srctree
 21 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22 srctree := $(patsubst %/,%,$(dir $(srctree)))
 23 srctree := $(patsubst %/,%,$(dir $(srctree)))
 24 #$(info Determined 'srctree' to be $(srctree))
 25 endif
 26 
 27 INSTALL = install
 28 
 29 # Use DESTDIR for installing into a different root directory.
 30 # This is useful for building a package. The program will be
 31 # installed in this directory as if it was the root directory.
 32 # Then the build tool can move it later.
 33 DESTDIR ?=
 34 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35 
 36 include $(srctree)/tools/scripts/Makefile.arch
 37 
 38 ifeq ($(LP64), 1)
 39   libdir_relative = lib64
 40 else
 41   libdir_relative = lib
 42 endif
 43 
 44 prefix ?= /usr/local
 45 libdir = $(prefix)/$(libdir_relative)
 46 man_dir = $(prefix)/share/man
 47 man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48 
 49 export man_dir man_dir_SQ INSTALL
 50 export DESTDIR DESTDIR_SQ
 51 
 52 include $(srctree)/tools/scripts/Makefile.include
 53 
 54 # copy a bit from Linux kbuild
 55 
 56 ifeq ("$(origin V)", "command line")
 57   VERBOSE = $(V)
 58 endif
 59 ifndef VERBOSE
 60   VERBOSE = 0
 61 endif
 62 
 63 INCLUDES = -I$(or $(OUTPUT),.) \
 64            -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi
 65 
 66 export prefix libdir src obj
 67 
 68 # Shell quotes
 69 libdir_SQ = $(subst ','\'',$(libdir))
 70 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 71 
 72 OBJ             = $@
 73 N               =
 74 
 75 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_VERSION)
 76 LIB_FILE        = libbpf.a libbpf.so*
 77 PC_FILE         = libbpf.pc
 78 
 79 # Set compile option CFLAGS
 80 ifdef EXTRA_CFLAGS
 81   CFLAGS := $(EXTRA_CFLAGS)
 82 else
 83   CFLAGS := -g -O2
 84 endif
 85 
 86 # Append required CFLAGS
 87 override CFLAGS += -std=gnu89
 88 override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
 89 override CFLAGS += -Werror -Wall
 90 override CFLAGS += $(INCLUDES)
 91 override CFLAGS += -fvisibility=hidden
 92 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 93 override CFLAGS += $(CLANG_CROSS_FLAGS)
 94 
 95 # flags specific for shared library
 96 SHLIB_FLAGS := -DSHARED -fPIC
 97 
 98 ifeq ($(VERBOSE),1)
 99   Q =
100 else
101   Q = @
102 endif
103 
104 # Disable command line variables (CFLAGS) override from top
105 # level Makefile (perf), otherwise build Makefile will get
106 # the same command line setup.
107 MAKEOVERRIDES=
108 
109 all:
110 
111 OUTPUT ?= ./
112 OUTPUT := $(abspath $(OUTPUT))/
113 export srctree OUTPUT CC LD CFLAGS V
114 include $(srctree)/tools/build/Makefile.include
115 
116 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/
117 STATIC_OBJDIR   := $(OUTPUT)staticobjs/
118 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o
119 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o
120 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h
121 BPF_GENERATED   := $(BPF_HELPER_DEFS)
122 
123 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB_TARGET))
124 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB_FILE))
125 PC_FILE         := $(addprefix $(OUTPUT),$(PC_FILE))
126 
127 TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
128 
129 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
130                            cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
131                            sed 's/\[.*\]//' | \
132                            awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
133                            sort -u | wc -l)
134 VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
135                               sed 's/\[.*\]//' | \
136                               awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
137                               grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
138 
139 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
140 
141 all: fixdep
142         $(Q)$(MAKE) all_cmd
143 
144 all_cmd: $(CMD_TARGETS) check
145 
146 $(SHARED_OBJDIR) $(STATIC_OBJDIR):
147         $(Q)mkdir -p $@
148 
149 $(BPF_IN_SHARED): force $(BPF_GENERATED) | $(SHARED_OBJDIR)
150         @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
151         (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
152         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
153         @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
154         (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
155         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
156         @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
157         (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
158         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
159         $(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(SHARED_OBJDIR) $(SHARED_OBJDIR)fixdep
160         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
161 
162 $(BPF_IN_STATIC): force $(BPF_GENERATED) | $(STATIC_OBJDIR)
163         $(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(STATIC_OBJDIR) $(STATIC_OBJDIR)fixdep
164         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
165 
166 $(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
167         $(QUIET_GEN)$(srctree)/scripts/bpf_doc.py --header \
168                 --file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
169 
170 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
171 
172 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED) $(VERSION_SCRIPT)
173         $(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS) \
174                 --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
175                 -Wl,--version-script=$(VERSION_SCRIPT) $< -lelf -lz -o $@
176         @ln -sf $(@F) $(OUTPUT)libbpf.so
177         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
178 
179 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
180         $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
181 
182 $(OUTPUT)libbpf.pc:
183         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
184                 -e "s|@LIBDIR@|$(libdir_SQ)|" \
185                 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
186                 < libbpf.pc.template > $@
187 
188 check: check_abi check_version
189 
190 check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT)
191         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then  \
192                 echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"        \
193                      "($(GLOBAL_SYM_COUNT)) does NOT match with num of"  \
194                      "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
195                      "Please make sure all LIBBPF_API symbols are"       \
196                      "versioned in $(VERSION_SCRIPT)." >&2;              \
197                 readelf -s --wide $(BPF_IN_SHARED) |                     \
198                     cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |   \
199                     sed 's/\[.*\]//' |                                   \
200                     awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
201                     sort -u > $(OUTPUT)libbpf_global_syms.tmp;           \
202                 readelf --dyn-syms --wide $(OUTPUT)libbpf.so |           \
203                     sed 's/\[.*\]//' |                                   \
204                     awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}'|  \
205                     grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |             \
206                     sort -u > $(OUTPUT)libbpf_versioned_syms.tmp;        \
207                 diff -u $(OUTPUT)libbpf_global_syms.tmp                  \
208                      $(OUTPUT)libbpf_versioned_syms.tmp;                 \
209                 rm $(OUTPUT)libbpf_global_syms.tmp                       \
210                    $(OUTPUT)libbpf_versioned_syms.tmp;                   \
211                 exit 1;                                                  \
212         fi
213 
214 HDR_MAJ_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MAJOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
215 HDR_MIN_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MINOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
216 
217 check_version: $(VERSION_SCRIPT) libbpf_version.h
218         @if [ "$(HDR_MAJ_VERSION)" != "$(LIBBPF_MAJOR_VERSION)" ]; then        \
219                 echo "Error: libbpf major version mismatch detected: "         \
220                      "'$(HDR_MAJ_VERSION)' != '$(LIBBPF_MAJOR_VERSION)'" >&2;  \
221                 exit 1;                                                        \
222         fi
223         @if [ "$(HDR_MIN_VERSION)" != "$(LIBBPF_MINOR_VERSION)" ]; then        \
224                 echo "Error: libbpf minor version mismatch detected: "         \
225                      "'$(HDR_MIN_VERSION)' != '$(LIBBPF_MINOR_VERSION)'" >&2;  \
226                 exit 1;                                                        \
227         fi
228 
229 define do_install_mkdir
230         if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
231                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
232         fi
233 endef
234 
235 define do_install
236         if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
237                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
238         fi;                                             \
239         $(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
240 endef
241 
242 install_lib: all_cmd
243         $(call QUIET_INSTALL, $(LIB_TARGET)) \
244                 $(call do_install_mkdir,$(libdir_SQ)); \
245                 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
246 
247 SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h             \
248             bpf_helpers.h bpf_tracing.h bpf_endian.h bpf_core_read.h         \
249             skel_internal.h libbpf_version.h usdt.bpf.h
250 GEN_HDRS := $(BPF_GENERATED)
251 
252 INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf
253 INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX)/, $(SRC_HDRS))
254 INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX)/, $(notdir $(GEN_HDRS)))
255 
256 $(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h
257         $(call QUIET_INSTALL, $@) \
258                 $(call do_install,$<,$(prefix)/include/bpf,644)
259 
260 $(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUTPUT)%.h
261         $(call QUIET_INSTALL, $@) \
262                 $(call do_install,$<,$(prefix)/include/bpf,644)
263 
264 install_headers: $(BPF_GENERATED) $(INSTALL_SRC_HDRS) $(INSTALL_GEN_HDRS)
265         $(call QUIET_INSTALL, libbpf_headers)
266 
267 install_pkgconfig: $(PC_FILE)
268         $(call QUIET_INSTALL, $(PC_FILE)) \
269                 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
270 
271 install: install_lib install_pkgconfig install_headers
272 
273 clean: fixdep-clean
274         $(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)                 \
275                 *~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_GENERATED)                \
276                 $(SHARED_OBJDIR) $(STATIC_OBJDIR)                            \
277                 $(addprefix $(OUTPUT),                                       \
278                             *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
279 
280 PHONY += force cscope tags check check_abi check_version
281 force:
282 
283 cscope:
284         ls *.c *.h > cscope.files
285         cscope -b -q -I $(srctree)/include -f cscope.out
286 
287 tags:
288         $(RM) -f TAGS tags
289         ls *.c *.h | xargs $(TAGS_PROG) -a
290 
291 # Declare the contents of the .PHONY variable as phony.  We keep that
292 # information in a variable so we can use it in if_changed and friends.
293 .PHONY: $(PHONY)
294 
295 # Delete partially updated (corrupted) files on error
296 .DELETE_ON_ERROR:
297 
298 help:
299         @echo 'libbpf common targets:'
300         @echo '  HINT: use "V=1" to enable verbose build'
301         @echo '  all     - build libraries and pkgconfig'
302         @echo '  clean   - remove all generated files'
303         @echo '  check   - check ABI and version info'
304         @echo ''
305         @echo 'libbpf install targets:'
306         @echo '  HINT: use "prefix"(defaults to "/usr/local") or "DESTDIR" (defaults to "/")'
307         @echo '        to adjust target destination, e.g. "make prefix=/usr/local install"'
308         @echo '  install          - build and install all headers, libraries and pkgconfig'
309         @echo '  install_headers  - install only headers to include/bpf'
310         @echo ''
311         @echo 'libbpf make targets:'
312         @echo '  tags    - use ctags to make tag information for source code browsing'
313         @echo '  cscope  - use cscope to make interactive source code browsing database'

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php